#ifndef BASEALT_SPICE_EC_PROXMOX_JSON_PARSER_H
#define BASEALT_SPICE_EC_PROXMOX_JSON_PARSER_H

#include <vector>

#include <QNetworkReply>

#include "proxmox-virtual-machine.h"

namespace Basealt {

struct TokenData
{
    QString username;
    QString ticket;
    QString token;
};

namespace ProxmoxJsonParser {

TokenData parseTokenResponse( QNetworkReply* reply );
std::vector<size_t> parseVirtualMachinesResponse( QNetworkReply* reply );
std::vector<QString> parseNodesResponse( QNetworkReply* reply );

VirtualMachine::Status
parseVirtualMachineCurrentStatusResponse( QNetworkReply* reply );

QString parseGetSpiceProxyResponse( QNetworkReply* reply );

QString parseVirtualMachineSetStatusResponse( QNetworkReply* reply );

} // namespace ProxmoxJsonParser
} // namespace Basealt

#endif // BASEALT_SPICE_EC_PROXMOX_JSON_PARSER_H
