#ifndef BASEALT_SPICE_EC_NODE_H
#define BASEALT_SPICE_EC_NODE_H

#include <memory>
#include <vector>

#include "proxmox-rest-client.h"
#include "proxmox-virtual-machine.h"

namespace Basealt {

class Node : public QObject
{
    Q_OBJECT
public:
    Node( const std::shared_ptr<ProxmoxRestClient>& restClient,
          const QString& id );

    void fetchVirtualMachines();

signals:
    void virtualMachinesFetched( const std::vector<std::shared_ptr<VirtualMachine>>& vms );
    void virtualMachinesFetchFailed( const QString& reason );

private slots:
    void onReplyFinished( QNetworkReply* reply );

private:
    std::shared_ptr<ProxmoxRestClient> _restClient;
    QString _id;
    std::vector<std::shared_ptr<VirtualMachine>> _virtualMachines;
    QNetworkReply* _virtualMachinesFetchReply;

    std::vector<std::shared_ptr<VirtualMachine>>
    processVirtualMachinesFetchReply( QNetworkReply* reply );
};

} // namespace Basealt

#endif // BASEALT_SPICE_EC_NODE_H
