#include "main-view.h"

#include <QMessageBox>

namespace {

const QString kAppName = "Spice Easy Connect";
const QString kErrorTitle = "An error occurred!";

const int kMinimumWidth = 480;
const int kMinimumHeight = 320;

} // namespace

namespace Basealt {

MainView::MainView( QWidget* parent, Qt::WindowFlags flags )
    : QMainWindow( parent, flags ),
      _stackedView( new QStackedWidget( this ) ),
      _settingsView( new SettingsView() ),
      _processView( new ProcessView() )
{
    _stackedView->addWidget( _settingsView );
    _stackedView->addWidget( _processView );

    setMinimumSize( kMinimumWidth, kMinimumHeight );
    setCentralWidget( _stackedView );
    setWindowTitle( kAppName );
}

void MainView::reportError( const QString& reason )
{
    QMessageBox::critical( this, kErrorTitle, reason );
}

} // namespace Basealt
